]> git.tuebingen.mpg.de Git - gsu.git/blobdiff - funcs/gsu
gsu: Make command line vars trump config file vars.
[gsu.git] / funcs / gsu
index 9bc7c7bcfb701aacb917e2604bde155871f26c65..d72f54f4faa9dfcf30e4baf8f1608e5972cc4cc5 100644 (file)
--- a/funcs/gsu
+++ b/funcs/gsu
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/bash
 # gsu -- the global subcommand utility
 # (C) 2006-2009 Andre Noll
 
@@ -149,7 +149,7 @@ com_prefs()
                local name= option_type= default_value= required=
                local description= help_text=
                eval "${gsu_options[$i]}"
-               eval val='"$'${gsu_name}_$name'"'
+               eval val='"$'${gsu_config_var_prefix}_$name'"'
                case "$required" in
                true|yes)
                        printf "# required"
@@ -163,6 +163,7 @@ com_prefs()
                        printf " [$default_value]"
                fi
                echo
+               [[ -n "$help_text" ]] && sed -e '/^[    ]*$/d; s/^[     ]*/#    /g' <<< "$help_text"
                printf "$name=$val"
                [[ "$val" == "$default_value" ]] && printf " # default"
                echo
@@ -283,17 +284,24 @@ export -f com_help
 # for errors and parses the config file.
 _gsu_check_options()
 {
-       local i conf="${gsu_config_file:=$HOME/.$gsu_name.rc}"
+       local i conf="${gsu_config_file:=$HOME/.$gsu_name.rc}" val
+
+       for ((i=0; i < ${#gsu_options[@]}; i++)); do
+               eval "${gsu_options[$i]}"
+               eval val='"'\$$name'"'
+               eval orig_${gsu_config_var_prefix}_$name='"'${val}'"'
+       done
 
        [[ -r "$conf" ]] && source "$conf"
 
        for ((i=0; i < ${#gsu_options[@]}; i++)); do
                local name= option_type= default_value= required=
                local description= help_text=
-               local val
+               local val orig_val
 
                eval "${gsu_options[$i]}"
 
+
                # Check name. It must be non-empty and consist of [a-zA-Z_0-9]
                # only.  Moreover it must not start with [a-zA-Z].
 
@@ -303,7 +311,12 @@ _gsu_check_options()
                echo "$name" | grep '^[a-zA-Z][a-zA-Z_0123456789]*$' &> /dev/null;
                [[ $? -ne 0 ]] && return
 
-               eval val='"'\$$name'"'
+               eval orig_val='"'\$orig_${gsu_config_var_prefix}_$name'"'
+               if [[ -z "$orig_val" ]]; then
+                       eval val='"'\$$name'"'
+               else
+                       val="$orig_val"
+               fi
                case "$required" in
                true|yes)
                        ret=-$E_GSU_NEED_VALUE
@@ -318,7 +331,7 @@ _gsu_check_options()
                        return
                esac
 
-               eval ${gsu_name}_$name='"'${val:=$default_value}'"'
+               eval ${gsu_config_var_prefix}_$name='"'${val:=$default_value}'"'
 
                # Check option type. ATM, only num and string are supported
                # Other types may be added without breaking compatibility
@@ -344,11 +357,15 @@ gsu()
        local i
 
        _gsu_self="$(basename $0)"
+       gsu_name="${gsu_name:=$_gsu_self}"
+       gsu_config_var_prefix="${gsu_config_var_prefix:=$gsu_name}"
        _gsu_init_errors
        _gsu_check_options
        if [[ "$ret" -lt 0 ]]; then
-               gsu_err_msg
-               exit 1
+               if [[ "$1" != "help" && "$1" != "man" && "$1" != "prefs" ]]; then
+                       gsu_err_msg
+                       exit 1
+               fi
        fi
        _gsu_available_commands
        gsu_cmds="$result"